{ config, lib, pkgs, ... }:

let
  domain = "tube.giugl.io";
in
{
  services.invidious = {
    enable = true;
    package = pkgs.unstablePkgs.invidious;
  };
  
  architect.vhost.${domain} = {
    dnsInterfaces = [ "lan" "tailscale" "wireguard" ];
    locations."/".port = config.services.invidious.port;
  };
}
